/*
** digiblaster.acepansion public API
*/

#ifndef ACEPANSION_H
#define ACEPANSION_H

#include <exec/libraries.h>
#include <exec/semaphores.h>


#define LIBNAME "digiblaster.acepansion"
#define VERSION 1
#define REVISION 1
#define DATE "02.06.2020"
#define COPYRIGHT " 2015-2020 Philippe Rimauro"

#define API_VERSION 1


BOOL InitResources(VOID);
VOID FreeResources(VOID);


struct ACEpansionPlugin * CreatePlugin(CONST_STRPTR *toolTypes, struct SignalSemaphore *sema);
VOID DeletePlugin(struct ACEpansionPlugin *plugin);
BOOL ActivatePlugin(struct ACEpansionPlugin *plugin, BOOL status);

VOID Reset(struct ACEpansionPlugin * plugin);
VOID Emulate(struct ACEpansionPlugin *plugin, ULONG *signals);

VOID WriteIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE value);
VOID ReadIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE * value);
VOID GetAudio(struct ACEpansionPlugin *plugin, SHORT * leftSample, SHORT *rightSample);
VOID Printer(struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, BOOL *busy);
VOID Cursor(struct ACEpansionPlugin *plugin);
VOID AcknowledgeInterrupt(struct ACEpansionPlugin *plugin, UBYTE *ivr);

#endif /* ACEPANSION_H */

