/*
** kempstonmouse.acepansion public API
*/

#ifndef ACEPANSION_H
#define ACEPANSION_H

#include <exec/types.h>
#include <exec/semaphores.h>


#define LIBNAME "kempstonmouse.acepansion"
#define VERSION 1
#define REVISION 2
#define DATE "11.07.2022"
#define COPYRIGHT " 2016-2022 Philippe Rimauro"

#define API_VERSION 7


BOOL InitResources(VOID);
VOID FreeResources(VOID);


struct ACEpansionPlugin * CreatePlugin(CONST_STRPTR *toolTypes, struct SignalSemaphore *sema);
VOID DeletePlugin(struct ACEpansionPlugin *plugin);
BOOL ActivatePlugin(struct ACEpansionPlugin *plugin, BOOL status);
STRPTR * GetPrefsPlugin(struct ACEpansionPlugin *plugin, APTR pool);

VOID Reset(struct ACEpansionPlugin *plugin);
VOID Emulate(struct ACEpansionPlugin *plugin, ULONG *signals);

VOID WriteIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE value);
VOID ReadIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE *value);
BOOL WriteMem(struct ACEpansionPlugin *plugin, USHORT address, UBYTE value);
VOID ReadMem(struct ACEpansionPlugin *plugin, USHORT address, UBYTE *value, BOOL opcodeFetch);

VOID GetAudio(struct ACEpansionPlugin *plugin, SHORT *leftSample, SHORT *rightSample);

VOID Printer(struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, BOOL *busy);
VOID Joystick(struct ACEpansionPlugin *plugin, BOOL com1, BOOL com2, UBYTE *ioData);

VOID AnalogInput(struct ACEpansionPlugin *plugin, UBYTE channel, UBYTE *value);

VOID AcknowledgeInterrupt(struct ACEpansionPlugin *plugin, UBYTE *ivr);
VOID ReturnInterrupt(struct ACEpansionPlugin *plugin);

VOID Cursor(struct ACEpansionPlugin *plugin);

VOID HostGamepadList(struct ACEpansionPlugin *plugin, STRPTR *list);
VOID HostGamepadEvent(struct ACEpansionPlugin *plugin, UBYTE index, USHORT buttons, BYTE ns, BYTE ew, BYTE lx, BYTE ly, BYTE rx, BYTE ry);

VOID HostMouseEvent(struct ACEpansionPlugin *plugin, UBYTE buttons, SHORT deltaX, SHORT deltaY);

VOID HostLightDeviceDiodePulse(struct ACEpansionPlugin *plugin);
VOID HostLightDeviceButton(struct ACEpansionPlugin *plugin, BOOL pressed);

#endif /* ACEPANSION_H */

