/*
** multiface2.acepansion public API
*/

#ifndef ACEPANSION_H
#define ACEPANSION_H

#include <exec/libraries.h>
#include <exec/semaphores.h>


#define LIBNAME "multiface2.acepansion"
#define VERSION 1
#define REVISION 0
#define DATE "14.05.2021"
#define COPYRIGHT " 2021 Philippe Rimauro"

#define API_VERSION 6


BOOL InitResources(VOID);
VOID FreeResources(VOID);


struct ACEpansionPlugin * CreatePlugin(CONST_STRPTR *toolTypes, struct SignalSemaphore *sema);
VOID DeletePlugin(struct ACEpansionPlugin *plugin);
BOOL ActivatePlugin(struct ACEpansionPlugin *plugin, BOOL status);
STRPTR * GetPrefsPlugin(struct ACEpansionPlugin *plugin, APTR pool);

VOID Reset(struct ACEpansionPlugin * plugin);
VOID Emulate(struct ACEpansionPlugin *plugin, ULONG *signals);

VOID WriteIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE value);
VOID ReadIO(struct ACEpansionPlugin *plugin, USHORT port, UBYTE *value);
BOOL WriteMem(struct ACEpansionPlugin *plugin, USHORT address, UBYTE value);
BOOL ReadMem(struct ACEpansionPlugin *plugin, USHORT address, UBYTE *value, BOOL opcode);

VOID GetAudio(struct ACEpansionPlugin *plugin, SHORT *leftSample, SHORT *rightSample);

VOID Printer(struct ACEpansionPlugin *plugin, UBYTE data, BOOL strobe, BOOL *busy);
VOID Joystick(struct ACEpansionPlugin *plugin, BOOL com1, BOOL com2, UBYTE *ioData);

VOID LightDeviceDiodePulse(struct ACEpansionPlugin *plugin);
VOID LightDeviceButton(struct ACEpansionPlugin *plugin, BOOL pressed);

VOID AcknowledgeInterrupt(struct ACEpansionPlugin *plugin, UBYTE *ivr);
VOID ReturnInterrupt(struct ACEpansionPlugin *plugin);

VOID Cursor(struct ACEpansionPlugin *plugin);

#endif /* ACEPANSION_H */

