@DATABASE "acepansion/lib_header.h"
@MASTER   "Cubic:Workspace/ACE/sdk/include/acepansion/lib_header.h"
@REMARK   This file was created by ADtoHT 2.1 on 14-Sep-22 15:15:05
@REMARK   Do not edit
@REMARK   ADtoHT is  1993-1995 Christian Stieber

@NODE MAIN "acepansion/lib_header.h"

@{"acepansion/lib_header.h" LINK File}


@{b}#defines@{ub}

@{"UNUSED" LINK "acepansion/lib_header.h/File" 15}

@ENDNODE
@NODE File "acepansion/lib_header.h"
/*
** ACEpansion generic library header
**
** Copyright  2020 by Philippe Rimauro
*/

#ifndef LIB_HEADER_H
#define LIB_HEADER_H

#include <exec/types.h>



#ifdef __GNUC__
#define @{"UNUSED" LINK "File" 17} __attribute__((unused))
#else
#define @{"UNUSED" LINK "File" 15}
#endif



extern struct Library *SysBase;



/****** lib_header/GetString ************************************************

* NAME
*  GetString
*
* SYNOPSIS
*  STRPTR GetString(LONG id)
*
* FUNCTION
*  Retreive a translated string from the library's catalog.
*
* INPUTS
*  id
*    Identifier of the string to retrieve.
*
* RESULT
*  A pointer to the corresponding string translated in the current language, or
*  in English if it was not available.
*
* NOTES
*  A NULL pointer may be returned if the provided identifier is invalid.
*
* SEE ALSO
*
*****************************************************************************
*
*/

STRPTR GetString(LONG id);



/****** lib_header/MakeToolType *********************************************

* NAME
*  MakeToolType
*
* SYNOPSIS
*  STRPTR MakeToolType(APTR pool, CONST_STRPTR key, CONST_STRPTR val)
*
* FUNCTION
*  Allocate and format a tooltype from a key and a string value.
*
* INPUTS
*  pool
*    Pointer to the memory pool to use for allocation.
*  key
*    Pointer to the key string of the tooltype.
*  val
*    Pointer to the string value of the tooltype, or NULL if the tooltype to
*    create do not have a value (i.e. if it is a switch).
*
* RESULT
*  A pointer to string containing the tooltype in the form of "key=val" or "key"
*  (in case val was NULL).
*
* NOTES
*  A NULL pointer may be returned when running out of memory.
*
* SEE ALSO
*
*****************************************************************************
*
*/

STRPTR MakeToolType(APTR pool, CONST_STRPTR key, CONST_STRPTR val);



/****** lib_header/MakeToolTypeNum ******************************************

* NAME
*  MakeToolTypeNum
*
* SYNOPSIS
*  STRPTR MakeToolType(APTR pool, CONST_STRPTR key, LONG val)
*
* FUNCTION
*  Allocate and format a tooltype from a key and a numeric value.
*
* INPUTS
*  pool
*    Pointer to the memory pool to use for allocation.
*  key
*    Pointer to the key string of the tooltype.
*  val
*    Numeric value of the tooltype.
*
* RESULT
*  A pointer to string containing the tooltype in the form of "key=val".
*
* NOTES
*
* SEE ALSO
*
*****************************************************************************
*
*/

STRPTR MakeToolTypeNum(APTR pool, CONST_STRPTR key, LONG val);

#endif /* LIB_HEADER_H */
@ENDNODE
